diff --git a/src/backend/postmaster/postmaster.c b/src/backend/postmaster/postmaster.c
index f5c8e9d..2211532 100644
--- a/src/backend/postmaster/postmaster.c
+++ b/src/backend/postmaster/postmaster.c
@@ -113,6 +113,7 @@
 #include "postmaster/pgarch.h"
 #include "postmaster/postmaster.h"
 #include "postmaster/syslogger.h"
+#include "replication/logicalworker.h"
 #include "replication/walsender.h"
 #include "storage/fd.h"
 #include "storage/ipc.h"
@@ -416,6 +417,7 @@ static void maybe_start_bgworker(void);
 static bool CreateOptsFile(int argc, char *argv[], char *fullprogname);
 static pid_t StartChildProcess(AuxProcType type);
 static void StartAutovacuumWorker(void);
+static void register_internal_bgworkers(void);
 static void InitPostmasterDeathWatchHandle(void);
 
 /*
@@ -925,6 +927,12 @@ PostmasterMain(int argc, char *argv[])
 #endif
 
 	/*
+	 * Register internal bgworkers before we give external modules chance
+	 * to do the same.
+	 */
+	register_internal_bgworkers();
+
+	/*
 	 * process any libraries that should be preloaded at postmaster start
 	 */
 	process_shared_preload_libraries();
@@ -5641,6 +5649,39 @@ assign_backendlist_entry(RegisteredBgWorker *rw)
 }
 
 /*
+ * Register internal background workers.
+ *
+ * This is here mainly because the permanent bgworkers are normally allowed
+ * to be registered only when share preload libraries are loaded which does
+ * not work for the internal ones.
+ */
+static void
+register_internal_bgworkers(void)
+{
+	internal_bgworker_registration_in_progress = true;
+
+	/* Register the logical replication worker launcher if appropriate. */
+	if (!IsBinaryUpgrade && max_logical_replication_workers > 0)
+	{
+		BackgroundWorker bgw;
+
+		bgw.bgw_flags =	BGWORKER_SHMEM_ACCESS |
+			BGWORKER_BACKEND_DATABASE_CONNECTION;
+		bgw.bgw_start_time = BgWorkerStart_RecoveryFinished;
+		bgw.bgw_main = ApplyLauncherMain;
+		snprintf(bgw.bgw_name, BGW_MAXLEN,
+				 "logical replication launcher");
+		bgw.bgw_restart_time = 5;
+		bgw.bgw_notify_pid = 0;
+		bgw.bgw_main_arg = (Datum) 0;
+
+		RegisterBackgroundWorker(&bgw);
+	}
+
+	internal_bgworker_registration_in_progress = false;
+}
+
+/*
  * If the time is right, start one background worker.
  *
  * As a side effect, the bgworker control variables are set or reset whenever
diff --git a/src/backend/replication/libpqwalreceiver/libpqwalreceiver.c b/src/backend/replication/libpqwalreceiver/libpqwalreceiver.c
index f28a792..4c4d441 100644
--- a/src/backend/replication/libpqwalreceiver/libpqwalreceiver.c
+++ b/src/backend/replication/libpqwalreceiver/libpqwalreceiver.c
@@ -60,6 +60,7 @@ static void libpqrcv_readtimelinehistoryfile(WalReceiverConnHandle *handle,
 static char *libpqrcv_create_slot(WalReceiverConnHandle *handle,
 								  char *slotname, bool logical,
 								  XLogRecPtr *lsn);
+static void libpqrcv_drop_slot(WalReceiverConnHandle *handle, char *slotname);
 static bool libpqrcv_startstreaming_physical(WalReceiverConnHandle *handle,
 								 TimeLineID tli, XLogRecPtr startpoint,
 								 char *slotname);
@@ -96,6 +97,7 @@ _PG_walreceirver_conn_init(WalReceiverConnAPI *wrcapi)
 	wrcapi->identify_system = libpqrcv_identify_system;
 	wrcapi->readtimelinehistoryfile = libpqrcv_readtimelinehistoryfile;
 	wrcapi->create_slot = libpqrcv_create_slot;
+	wrcapi->drop_slot = libpqrcv_drop_slot;
 	wrcapi->startstreaming_physical = libpqrcv_startstreaming_physical;
 	wrcapi->startstreaming_logical = libpqrcv_startstreaming_logical;
 	wrcapi->endstreaming = libpqrcv_endstreaming;
@@ -274,7 +276,7 @@ libpqrcv_create_slot(WalReceiverConnHandle *handle, char *slotname,
 
 	if (PQresultStatus(res) != PGRES_TUPLES_OK)
 	{
-		elog(FATAL, "could not crate replication slot \"%s\": %s\n",
+		elog(ERROR, "could not crate replication slot \"%s\": %s\n",
 			 slotname, PQerrorMessage(handle->streamConn));
 	}
 
@@ -287,6 +289,28 @@ libpqrcv_create_slot(WalReceiverConnHandle *handle, char *slotname,
 	return snapshot;
 }
 
+/*
+ * Drop replication slot.
+ */
+static void
+libpqrcv_drop_slot(WalReceiverConnHandle *handle, char *slotname)
+{
+	PGresult	   *res;
+	char			cmd[256];
+
+	snprintf(cmd, sizeof(cmd),
+			 "DROP_REPLICATION_SLOT \"%s\"", slotname);
+
+	res = libpqrcv_PQexec(handle, cmd);
+
+	if (PQresultStatus(res) != PGRES_COMMAND_OK)
+	{
+		elog(ERROR, "could not drop replication slot \"%s\": %s\n",
+			 slotname, PQerrorMessage(handle->streamConn));
+	}
+
+	PQclear(res);
+}
 
 /*
  * Start streaming WAL data from given startpoint and timeline.
@@ -353,7 +377,7 @@ libpqrcv_startstreaming_logical(WalReceiverConnHandle *handle,
 					 (uint32) (startpoint >> 32),
 					 (uint32) startpoint);
 
-	/* Send options */
+	/* Add options */
 	if (options)
 		appendStringInfo(&cmd, "( %s )", options);
 
diff --git a/src/backend/replication/logical/Makefile b/src/backend/replication/logical/Makefile
index 438811e..ab6e11e 100644
--- a/src/backend/replication/logical/Makefile
+++ b/src/backend/replication/logical/Makefile
@@ -14,7 +14,8 @@ include $(top_builddir)/src/Makefile.global
 
 override CPPFLAGS := -I$(srcdir) $(CPPFLAGS)
 
-OBJS = decode.o logical.o logicalfuncs.o message.o origin.o proto.o \
-	   publication.o reorderbuffer.o snapbuild.o subscription.o
+OBJS = apply.o decode.o launcher.o logical.o logicalfuncs.o message.o \
+	   origin.o proto.o publication.o reorderbuffer.o snapbuild.o \
+	   subscription.o
 
 include $(top_srcdir)/src/backend/common.mk
